import checkers.quals.*;

class PolyReads {

    @Mutable @Assignable String mString;
    String tmString;
    @ReadOnly String roString;

    PolyReads (@PolyRead String s) @PolyRead {
        mString = s;           // error, cannot assign to mutable
        tmString = s;          // assignable at constructor
        roString = s;          // assignable at constructor

        @PolyRead String a = s; // ok
        @PolyRead String b = a; // ok

        a = mString;           // ok
        a = tmString;          // ok
        a = roString;          // error

        mString = a;           // error
        tmString = a;          // ok
        roString = a;          // ok
    }

    @PolyRead String testAsMutableReceiver(@PolyRead String s) {
        mString = s;           // error, cannot assign to mutable
        tmString = s;          // error, cannot assign to mutable
        roString = s;          // ok

        @PolyRead String a = s; // ok
        @PolyRead String b = a; // ok

        a = mString;           // ok
        a = tmString;          // ok
        a = roString;          // error

        mString = a;           // error
        tmString = a;          // error
        roString = a;          // ok

        return null;
    }

    @PolyRead String testAsReadOnlyReceiver(@PolyRead String s) @ReadOnly {
        mString = s;           // error, s might be readonly
        tmString = s;          // error, local field, and unassignable (s readonly, mutable class, for example)
        roString = s;          // error, local field

        @PolyRead String a = s; // ok
        @PolyRead String b = a; // ok

        a = mString;           // ok
        a = tmString;          // error, a might be mutable
        a = roString;          // error, a might be mutable

        mString = a;           // error, a might be readonly
        tmString = a;          // error, local field, and unassignable (s readonly, mutable class, for example)
        roString = a;          // error, local field

        return null;
    }

    @PolyRead String testAsPolyReadReceiver(@PolyRead String s) @PolyRead {
        mString = s;           // error, s might be readonly
        tmString = s;          // error, local field
        roString = s;          // error, local field

        @PolyRead String a = s; // ok
        @PolyRead String b = a; // ok

        a = mString;           // ok
        a = tmString;          // ok
        a = roString;          // error, a might be mutable

        mString = a;           // error, a might be readonly
        tmString = a;          // error, local field
        roString = a;          // error, local field

        return null;
    }



}
